#!/usr/bin/env python
# -*- Python -*-

import sys
import time
import os

#
# set up user environment
#  RtmToolsDir, RtmDir, etc.
#
sys.path.append("..")
from set_env import *   

#
# import user tools
#
sys.path.append(".")
save_path = sys.path[:]
sys.path.append(Rh2LibDir)
from rtc_handle import *
sys.path = save_path

#
# import stub files
# 
#import _GlobalIDL

def assign_variables(env) :
  # rtc
  global battery, rh2ctrl
  battery = env.name_space[Rh2CtrlNS1].rtc_handles['BatteryWatcher0.rtc']
  rh2ctrl = env.name_space[Rh2CtrlNS2].rtc_handles['RHCtrl0.rtc']

def make_connectors(env):
  env.con_list=[]
  con = ServiceConnector([battery.services['BatteryAlert'],rh2ctrl.services['BatteryCtrlProv']])
  env.con_list.append(con)

#
# connection control
#
def connect_all(env) :
  for con in env.con_list :
    con.connect()
def disconnect_all(env) :
  for con in env.con_list :
    con.disconnect()
def connect_list(env,ll) :
  for i in ll :
    env.con_list[i].connect()
def disconnect_list(env,ll) :
  for i in ll :
    env.con_list[i].disconnect()
#
#
#
def activate_all() :
  rh2ctrl.activate()
  time.sleep(3)
  battery.activate()
def deactivate_all() :
  battery.deactivate()
  time.sleep(3)
  rh2ctrl.deactivate()
#
# create env
#
env = RtmEnv(sys.argv,[Rh2CtrlNS1,Rh2CtrlNS2])
for ns in env.name_space :
  env.name_space[ns].list_obj()
assign_variables(env)
make_connectors(env)
