// -*- C++ -*-
/*!
 * @file  TmPose2D_TmPosition.cpp
 * @brief DataConversionRTC
 * @date $Date$
 *
 * $Id$
 */

#include "TmPose2D_TmPosition.h"

// Module specification
// <rtc-template block="module_spec">
static const char* TmPose2D_TmPosition_spec[] =
  {
    "implementation_id", "TmPose2D_TmPosition",
    "type_name",         "TmPose2D_TmPosition",
    "description",       "DataConversionRTC",
    "version",           "1.0.0",
    "vendor",            "AIST",
    "category",          "tool",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "5",
    "language",          "C++",
    "lang_type",         "compile",
    "exec_cxt.periodic.rate", "1.0",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
TmPose2D_TmPosition::TmPose2D_TmPosition(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_inIn("in", m_in),
    m_outOut("out", m_out)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
TmPose2D_TmPosition::~TmPose2D_TmPosition()
{
}



RTC::ReturnCode_t TmPose2D_TmPosition::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("in", m_inIn);
  
  // Set OutPort buffer
  registerOutPort("out", m_outOut);

  // add:s [dataport callback] 2011.02.23 by rtc-center
  m_epos = new ExecPos(this);
  m_inIn.addConnectorDataListener(ON_BUFFER_WRITE, m_epos);
  // add:e [dataport callback] 2011.02.23 by rtc-center
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t TmPose2D_TmPosition::onExecute(RTC::UniqueId ec_id)
{
#if 0
	while(!m_inIn.isEmpty()){
		std::cout << "m_inIn.read()" << std::endl;
		m_inIn.read();
    }

	m_out.x = m_in.data.position.x;
	m_out.y = m_in.data.position.y;
	m_out.theta = m_in.data.heading;
	m_outOut.write();
#endif
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TmPose2D_TmPosition::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void TmPose2D_TmPositionInit(RTC::Manager* manager)
  {
    coil::Properties profile(TmPose2D_TmPosition_spec);
    manager->registerFactory(profile,
                             RTC::Create<TmPose2D_TmPosition>,
                             RTC::Delete<TmPose2D_TmPosition>);
  }
  
};


