// -*-C++-*-
/*!
 * @file  com_RHHandWrapSVC_impl.h
 * @brief Service implementation header of com_RHHandWrap.idl
 *
 */

#include "com_RHHandWrapSkel.h"
#include "rtm/idl/BasicDataType.hh"
#include <rtm/SystemLogger.h>

#ifndef COM_RHHANDWRAPSVC_IMPL_H
#define COM_RHHANDWRAPSVC_IMPL_H

double calc_tm_dif(RTC::Time tm1, RTC::Time tm2);
int diff_check(double num1, double num2, double diff);
 
/*!
 * @class ComToolCtrlSVC_impl
 * Example class implementing IDL interface ComToolCtrl
 */
class ComToolCtrlSVC_impl
 : public virtual POA_ComToolCtrl,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~ComToolCtrlSVC_impl();
   RTC::Logger rtclog; 

 public:
  /*!
   * @brief standard constructor
   */
   ComToolCtrlSVC_impl();
  /*!
   * @brief destructor
   */
   virtual ~ComToolCtrlSVC_impl();

   // attributes and operations
   CORBA::UShort gripper_open();
   CORBA::UShort gripper_close();
   CORBA::UShort get_cond();
   CORBA::UShort get_mode();
   CORBA::UShort gripper_stop();
   int action_mode; 	//動作モード  0:READY, 1:OPEN, 2:CLOSE
   int condition;   	//状態フラグ  0:閉完了 1:開完了 2:動作中 3:中断
   RTC::Time s_tm;   //グリッパー動作開始時刻

};



#endif // COM_RHHANDWRAPSVC_IMPL_H


