// -*-C++-*-
/*!
 * @file  itempositionSVC_impl.cpp
 * @brief Service implementation code of itemposition.idl
 *
 */

#include "itempositionSVC_impl.h"

double comparisonVal;
int bar_val;

/*
 * Example implementational code for IDL interface item_position
 */
item_positionSVC_impl::item_positionSVC_impl()
{
  // Please add extra constructor code here.
  flag = 1;
}


item_positionSVC_impl::~item_positionSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Short item_positionSVC_impl::get_item_position(CORBA::Short& up_l, CORBA::Short& up_r, CORBA::Short& down_l, CORBA::Short& down_r)
{
  // setting
  if(flag ==1){
    bar_val =m_int_match_level;
    comparisonVal = (double)m_int_match_level /100;
    flag = 0;
  }

  up_l=up_r=down_l=down_r=0;

  // TrackBar
  if(m_int_disp > 0){   // 0:non-display 1:display
    cvCreateTrackbar("matching_level", "Capture", &bar_val, 100, on_trackbar);
  }

  src = cvCreateImage( cvSize(m_int_width,m_int_height),IPL_DEPTH_8U, 1);
 
  // capture
  for(int i=0; i < 5; i++){ // おまじない
    camera_src=cvQueryFrame(capture);
  }

  if((camera_src->width == m_int_width)&&(camera_src->height == m_int_height)){

    /*inport part end*/
    cvCvtColor(camera_src,src,CV_BGR2GRAY);

    double minVal=0,maxVal=0;
    CvPoint minLoc,maxLoc,opposite;

    // 1st matching
    dst = cvCreateImage( cvSize(m_int_width+1-cdst->width,m_int_height-cdst->height+1),IPL_DEPTH_32F, 1);
    cvMatchTemplate(src,cdst,dst,CV_TM_CCOEFF_NORMED);
    cvMinMaxLoc(dst,&minVal,&maxVal,&minLoc,&maxLoc,NULL);
    if(maxVal > comparisonVal){
      opposite.x=maxLoc.x+cdst->width;
      opposite.y=maxLoc.y+cdst->height;
      cvRectangle(camera_src,maxLoc,opposite,CV_RGB(0,0,255),3,8,0);
      up_l = 1;
    }
    cvReleaseImage(&dst);

    // 2nd matching
    dst = cvCreateImage( cvSize(m_int_width+1-cdst_two->width,m_int_height-cdst_two->height+1),IPL_DEPTH_32F, 1);
    cvMatchTemplate(src,cdst_two,dst,CV_TM_CCOEFF_NORMED);
    CvPoint opposite_two;
    cvMinMaxLoc(dst,&minVal,&maxVal,&minLoc,&maxLoc,NULL);
    if(maxVal > comparisonVal){
      opposite_two.x=maxLoc.x+cdst_two->width;
      opposite_two.y=maxLoc.y+cdst_two->height;
      cvRectangle(camera_src,maxLoc,opposite_two,CV_RGB(255,0,0),3,8,0);
      up_r = 1;
    }
    cvReleaseImage(&dst);

    // 3rd matching
    dst = cvCreateImage( cvSize(m_int_width+1-cdst_three->width,m_int_height-cdst_three->height+1),IPL_DEPTH_32F, 1);
    CvPoint opposite_three;
    cvMatchTemplate(src,cdst_three,dst,CV_TM_CCOEFF_NORMED);
    cvMinMaxLoc(dst,&minVal,&maxVal,&minLoc,&maxLoc,NULL);
    if(maxVal > comparisonVal){
      opposite_three.x=maxLoc.x+cdst_three->width;
      opposite_three.y=maxLoc.y+cdst_three->height;
      cvRectangle(camera_src,maxLoc,opposite_three,CV_RGB(0,255,0),3,8,0);
      down_l = 1;
    }
    cvReleaseImage(&dst);

    // 4th matching
    dst = cvCreateImage( cvSize(m_int_width+1-cdst_four->width,m_int_height-cdst_four->height+1),IPL_DEPTH_32F, 1);
    CvPoint opposite_four;
    cvMatchTemplate(src,cdst_four,dst,CV_TM_CCOEFF_NORMED);
    cvMinMaxLoc(dst,&minVal,&maxVal,&minLoc,&maxLoc,NULL);
    if(maxVal > comparisonVal){
      opposite_four.x=maxLoc.x+cdst_four->width;
      opposite_four.y=maxLoc.y+cdst_four->height;
      cvRectangle(camera_src,maxLoc,opposite_four,CV_RGB(255,255,0),3,8,0);
      down_r = 1;
    }
    cvReleaseImage(&dst);
  }

  // window display
  if(m_int_disp > 0){   // 0:non-display 1:display
    cvShowImage("Capture", camera_src);
    // wait until displaying
    cvWaitKey(300);
  }

  printf("matching %d %d %d %d\n",up_l, up_r, down_l, down_r);

  cvReleaseImage(&src);

  return 0;
}

void on_trackbar(int val)
{
  // synchronization of trackbar 1 and trackbar 2
  bar_val = val;
  comparisonVal = double(val) / 100;
  printf("matching_leve %d  %f \n",val,comparisonVal);
}

void item_positionSVC_impl::OpenWindow()
{
  printf("OpenWindow() \n");
  cvNamedWindow("Capture", CV_WINDOW_AUTOSIZE);

}

void item_positionSVC_impl::CloseWindow()
{
  printf("closewindow \n");
  // release
  cvReleaseCapture(&capture);
  cvReleaseImage(&cdst);
  cvReleaseImage(&cdst_two);
  cvReleaseImage(&cdst_three);
  cvReleaseImage(&cdst_four);

  cvDestroyWindow("Capture");

  cvWaitKey(1000);
  cvDestroyAllWindows();
}

// End of example implementational code

