// -*-C++-*-
/*!
 * @file  itempositionSVC_impl.h
 * @brief Service implementation header of itemposition.idl
 *
 */

#include "itempositionSkel.h"

#ifndef ITEMPOSITIONSVC_IMPL_H
#define ITEMPOSITIONSVC_IMPL_H
 
#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>

#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <ctype.h>


/*!
 * @class item_positionSVC_impl
 * Example class implementing IDL interface item_position
 */
class item_positionSVC_impl
 : public virtual POA_item_position,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public

 public:
  /*!
   * @brief standard constructor
   */
   item_positionSVC_impl();
  /*!
   * @brief destructor
   */
   virtual ~item_positionSVC_impl();

   // attributes and operations
   CORBA::Short get_item_position(CORBA::Short& up_l, CORBA::Short& up_r, CORBA::Short& down_l, CORBA::Short& down_r);
   void CloseWindow();
   void OpenWindow();

   int length;
   int m_int_match_level;
   int m_int_disp;
   int m_int_width;
   int m_int_height;
   CvCapture* capture ;
   int flag;

   IplImage* src;
   IplImage* camera_src;
   IplImage* dst;
   IplImage* cdst;
   IplImage* cdst_two;
   IplImage* cdst_three;
   IplImage* cdst_four;
};

void  on_trackbar(int val);

#endif // ITEMPOSITIONSVC_IMPL_H
